Subject: bug#18132: Time for a smarter dired-guess-shell-alist-default? (dired-x.el)

From: Thierry Volpiatto <[email-masked]>
Date: Sun, 24 Oct 2021 05:10:13 +0000

Stefan Kangas <[email-masked]> writes:

> Reuben Thomas <[email-masked]> writes:
>
>> xdg-open uses the underlying desktop system's MIME infrastructure. For a
>> GNU system, that would most typically be GNOME, and its "gio open" (or on
>> older systems, gvfs-open) command.
>
> I don't see that shooting away blindly to xdg-open is satisfactory; the
> user should be able to a) know which command is being run before running
> it and b) modify it on the fly.  Maybe I want to open PDF:s first with
> one and then another PDF reader to see if it looks the same, just as I
> would be able to from a graphical file manager.
>
> Thus, the most important question to my mind is "how can we get the
> default command for a file in the best way".

Helm is using an alist to store (command . extension), if no command is
found, it uses mailcap to find a default unless the user specify a new
association interactively (prefix arg), user can add arguments to the
command if needed, before or after the filename(s) arguments.
In addition, on GNU/Linux it is possible to detach the process from
Emacs.
See helm-external.el, I am working on it currently.

-- 
Thierry